%define anolis_release 2
# Rolling_version represents the first rolling version of the current version taken from github. 
# Please increment this field when the rolling version of 2.1 is updated later.
%define rolling_version 2

Name:           luajit
Epoch:  	1
Version:        2.1
Release:        %{rolling_version}.%{anolis_release}%{?dist}
Summary:        Just-In-Time Compiler for Lua
License:        MIT
URL:            http://luajit.org/
Source0: 	https://github.com/LuaJIT/LuaJIT/archive/refs/tags/v%{version}.ROLLING.tar.gz
Source1:        https://github.com/LuaJIT/LuaJIT-test-cleanup/archive/refs/heads/master/LuaJIT-test-cleanup.tar.gz

# Add 'make check'
Patch0: luajit-2.1-make-check.patch
Patch1: 0001-LoongArch64-Add-target-architecture-selection.patch
Patch2: 0002-LoongArch64-Add-DynASM-support.patch
Patch3: 0003-LoongArch64-Add-register-assignments-for-the-interpr.patch
Patch4: 0004-LoongArch64-Add-stack-layout.patch
Patch5: 0005-LoongArch64-Add-some-general-macro-type-definitions-.patch
Patch6: 0006-LoongArch64-Add-pure-interpreter-backend.patch
Patch7: 0007-LoongArch64-Add-definitions-for-target-CPU.patch
Patch8: 0008-LoongArch64-Add-some-constant-definitions.patch
Patch9: 0009-LoongArch64-Add-LoongArch-instruction-emitter.patch
Patch10: 0010-LoongArch64-Add-IR-assembler-support.patch
Patch11: 0011-LoongArch64-Add-JIT-support-in-the-interpreter.patch
Patch12: 0012-LoongArch64-Add-CPU-feature-detection-when-init-JIT-.patch
Patch13: 0013-LoongArch64-Add-LoongArch-lp64-calling-conventions-a.patch
Patch14: 0014-LoongArch64-Add-FFI-C-callback-handling.patch
Patch15: 0015-LoongArch64-Add-FFI-support-in-the-interpreter.patch
Patch16: 0016-LoongArch64-Add-DWARF-and-ELF-header-definitions.patch
Patch17: 0017-LoongArch64-Add-support-for-LuaJIT-VM-builder.patch
Patch18: 0018-LoongArch64-Add-loongarch64-support-when-save-list-b.patch
Patch19: 0019-LoongArch64-Add-LoongArch64-disassembler-module.patch
Patch20: 0020-LoongArch64-Add-support-in-Makefile.patch
Patch21: 0021-LoongArch64-Upgrade-the-code-to-v2.1.ROLLING.patch
Patch22: 0022-LoongArch64-Sync-code-with-luajit2-s-6f2fa1d9.patch
Patch23: 0023-LOONGARCH64-Optimize-function-that-moves-i32-constan.patch
Patch24: 0024-LOONGARCH64-Optimize-emit_store-loadofs-and-emit_mov.patch
Patch25: 0025-LOONGARCH64-Optimize-emit_djml-function-and-remove-e.patch
Patch26: 0026-LOONGARCH64-Optimize-register-allocation-RID_R20-reg.patch
Patch27: 0027-LOONGARCH64-Add-stack-check-to-pcall-xpcall.patch
Patch28: 0028-LOONGARCH64-Fixed-the-register-allocation-bug-in-asm.patch
Patch29: 0029-LOONGARCH64-Fix-the-setup-for-the-end-of-each-trace-.patch
Patch30: 0030-LOONGARCH64-Standardize-coding-style-and-comments.patch
Patch31: 0031-LOONGARCH64-Fix-the-.ffunc_1-tostring.patch
Patch32: 0032-LOONGARCH64-Optimize-emit_-functions-to-eliminate-th.patch
Patch33: 0033-LOONGARCH64-Optimize-LOONGF_I-to-LOONGF_I-to-elimina.patch
Patch34: 0034-LOONGARCH64-Optimize-the-efficiency-of-getting-setti.patch
Patch35: 0035-LOONGARCH64-Fix-the-error-of-checking-the-immediate-.patch
Patch36: 0036-LOONGARCH64-Fix-emit_lsptr-and-emit_load-storeofs-fu.patch
Patch37: 0037-LOONGARCH64-Fix-the-bug-introduced-by-emit_-function.patch
Patch38: 0038-LOONGARCH64-Fix-the-way-to-load-UREF-op1-address-in-.patch
Patch39: 0039-LOONGARCH64-Fix-the-branch-that-is-out-of-range-when.patch
Patch40: 0040-LOONGARCH64-Optimized-the-bswap-function.patch
Patch41: 0041-LOONGARCH64-Fixed-the-bug-in-math_minmax-function.patch
Patch42: 0042-LOONGARCH64-Fixed-the-bug-in-pcall-and-xpcall-functi.patch
Patch43: 0043-LOONGARCH64-Optimized-the-use-of-some-conditional-br.patch
Patch44: 0044-LOONGARCH64-Fix-the-bug-in-Hard-float-round-to-integ.patch
Patch45: 0045-LOONGARCH64-Fixed-the-bugs-of-movfcsr2gr_2-movgr2fcs.patch
Patch46: 0046-LOONGARCH64-Optimizing-the-vm_next-function.patch
Patch47: 0047-LOONGARCH64-Bump-copyright-date.patch
Patch48: 0048-LOONGARCH64-Fix-pcall-error-case.patch
Patch49: 0049-LOONGARCH64-Fix-FP-to-integer-conversions.patch
Patch50: 0050-LOONGARCH64-Add-the-definition-and-usage-of-the-CFR.patch
Patch51: 0051-LOONGARCH64-Fix-vm_next-register-dirty-read-bug.patch
Patch52: 0052-LOONGARCH64-Fix-min-max-return-register-error.patch

BuildRequires:  gcc
BuildRequires:  make

%description
LuaJIT implements the full set of language features defined by Lua 5.1.
The virtual machine (VM) is API- and ABI-compatible to the standard
Lua interpreter and can be deployed as a drop-in replacement.

%package devel
Summary:        Development files for %{name}
Requires:       %{name} = %{epoch}:%{version}-%{release}

%description devel
This package contains development files for %{name}.

%package doc
Summary:        Doc files for %{name}
Requires:       %{name} = %{epoch}:%{version}-%{release}
BuildArch:      noarch

%description doc
Doc files for %{name}

%prep
%autosetup -n LuaJIT-%{version}.ROLLING -p1 -a1

ln -s LuaJIT-test-cleanup-master/bench bench
ln -s LuaJIT-test-cleanup-master/test test

# Enable Lua 5.2 features
sed -i -e '/-DLUAJIT_ENABLE_LUA52COMPAT/s/^#//' src/Makefile

# preserve timestamps (cicku)
sed -i -e '/install -m/s/-m/-p -m/' Makefile

%build
# Q= - enable verbose output
# E= @: - disable @echo messages
# NOTE: we use amalgamated build as per documentation suggestion doc/install.html
make amalg Q= E=@: PREFIX=%{_prefix} TARGET_STRIP=: \
           CFLAGS="%{build_cflags}" LDFLAGS="%{build_ldflags}" \
           MULTILIB=%{_lib} %{?_smp_mflags}

%install
# PREREL= - disable -betaX suffix
# INSTALL_TNAME - executable name
%make_install PREFIX=%{_prefix} \
              MULTILIB=%{_lib}

rm -rf _tmp_html ; mkdir _tmp_html
cp -a doc _tmp_html/html

# fix the bin name error
mv %{buildroot}/%{_bindir}/luajit-%{version}. %{buildroot}/%{_bindir}/luajit-%{version}
cp %{buildroot}/%{_bindir}/luajit-%{version} %{buildroot}/%{_bindir}/luajit

# Remove static .a
find %{buildroot} -type f -name *.a -delete -print

%check
# Don't fail the build on a check failure.
make check || true

%files
%license COPYRIGHT
%{_bindir}/%{name}
%{_bindir}/%{name}-%{version}
%{_libdir}/lib%{name}-*.so.*
%{_mandir}/man1/%{name}.1*
%{_datadir}/%{name}-%{version}/

%files devel
%doc _tmp_html/html/
%{_includedir}/%{name}-%{version}/
%{_libdir}/lib%{name}-*.so
%{_libdir}/pkgconfig/%{name}.pc

%files doc
%doc README

%changelog
* Mon Feb 17 2025 Huang Qiqi <huangqiqi@loongson.cn> - 1:2.1-2.2
- Optimize some code and fix some errors

* Mon Jan 15 2024 Huang Qiqi <huangqiqi@loongson.cn> - 1:2.1-2.1
- add patch to support LoongArch

* Wed Dec 20 2023 happy_orange <songnannan@linux.alibaba.com> - 1:2.1-1.1
- update to 2.1-ROLLINGe

* Wed Feb 15 2023 Chunmei Xu <xuchunmei@linux.alibaba.com> - 2.1.0-0.26beta3
- init from upstream
